//+------------------------------------------------------------------+
//|                                                       vladds.mq4 |
//|                                                  Vladimir Ivanov |
//|                                              mysss2019@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Vladimir Ivanov"
#property link      "mysss2019@gmail.com"
extern double Lots = 0.1;
extern color BuyColor = Green;
extern color SellColor = Red;
extern int MagicNumber = 34563;
extern int Slippage = 3;
static int inittime;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
  inittime = TimeCurrent();
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
  double MA1 = iMA(Symbol(),0,13,0,MODE_SMA,PRICE_CLOSE,0);
  static double newlots;
  static int buytime;
  static int selltime;
  double buyprofit10,buyprofit20,buyprofit25,sellprofit10,sellprofit20,sellprofit25,buyprofit1,sellprofit1;
  int a = 1,i,buys,sells,lastorder,hiorders;
//----
  if(Digits == 3 || Digits == 5)
    {
    a = 10;
    }
    
  for(i=0;i<OrdersTotal();i++)
    {
    if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
      {
      if(OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)
        {
        if(OrderType() == OP_BUY) buys++;
        if(OrderType() == OP_SELL) sells++;
        }
      }
    }
    
  for(i=0;i<OrdersHistoryTotal();i++)
    {
    if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY))
      {
      if(OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)
        {
        if(OrderOpenTime() >= inittime)
          {
          hiorders++;
          }
        }
      }
    }
    
  if(hiorders == 0)
    {
    newlots = Lots;
    }else
    {
    for(i=0;i<OrdersHistoryTotal();i++)
      {
      if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY))
        {
        if(OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)
          {
          if(OrderCloseTime() > lastorder)
            {
            lastorder = OrderCloseTime();
            newlots = OrderLots()*2;
            if(OrderType() == OP_BUY)
              {
              if((OrderClosePrice() - OrderOpenPrice()) > 9*a*Point) newlots = Lots;
              }
            if(OrderType() == OP_SELL)
              {
              if((OrderOpenPrice() - OrderClosePrice()) > 9*a*Point) newlots = Lots;
              }
            }
          }
        }
      }
    }
    
  if(newlots > MarketInfo(Symbol(),MODE_MAXLOT))
    {
    newlots = MarketInfo(Symbol(),MODE_MAXLOT);
    }
//----     
  if(((Ask > (MA1+3*Point*a)) && (Open[0] < (MA1+3*Point*a)) && (Ask < (MA1+5*Point*a))) || ((Low[0] < (MA1+3*Point*a)) && (Bid > (MA1+3*Point*a)) && (Bid < (MA1+5*Point*a))))
    {
    if(buytime != Time[0] && buys == 0 && sells == 0)
      {
        if(OrderSend(Symbol(),OP_BUY,newlots,Ask,Slippage,0,0,0,MagicNumber,0,BuyColor) > 0)
          {
          buytime = Time[0];
          }
      }
    }
  if(buys > 0 && Bid < (MA1-3*Point*a))
    {
    for(i=0;i<OrdersTotal();i++)
      {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
        {
        if(OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)
          {
          if(OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Green))
            {
            for(i=0;i<OrdersHistoryTotal();i++)
              {
              if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY))
                {
                if(OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)
                  {
                  if(OrderCloseTime() > lastorder)
                    {
                    lastorder = OrderCloseTime();
                    newlots = OrderLots()*2;
                    if(OrderType() == OP_BUY)
                      {
                      if((OrderClosePrice() - OrderOpenPrice()) > 9*a*Point) newlots = Lots;
                      }
                    if(OrderType() == OP_SELL)
                      {
                    if((OrderOpenPrice() - OrderClosePrice()) > 9*a*Point) newlots = Lots;
                      }
                    }
                  }
                }
              }
            if(newlots > MarketInfo(Symbol(),MODE_MAXLOT))
              {
              newlots = MarketInfo(Symbol(),MODE_MAXLOT);
              }
            if(OrderSend(Symbol(),OP_SELL,newlots,Bid,Slippage,0,0,0,MagicNumber,0,SellColor) > 0)
              {
              selltime = Time[0];
              }
            }
          }
        }
      }
    }
    
//----     
    
  if(((Bid < (MA1-3*Point*a)) && (Open[0] > (MA1-3*Point*a)) && (Bid > (MA1-5*Point*a))) || ((High[0] > (MA1-3*Point*a)) && (Ask < (MA1-3*Point*a)) && (Ask > (MA1-5*Point*a))))
    {
    if(selltime != Time[0] && sells == 0 && buys == 0)
      {
        if(OrderSend(Symbol(),OP_SELL,newlots,Bid,Slippage,0,0,0,MagicNumber,0,SellColor) > 0)
          {
          selltime = Time[0];
          }
      }
    }
  if(sells > 0 && Ask > (MA1+3*Point*a))
    {
    for(i=0;i<OrdersTotal();i++)
      {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
        {
        if(OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)
          {
          if(OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,Red))
            {
            for(i=0;i<OrdersHistoryTotal();i++)
              {
              if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY))
                {
                if(OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)
                  {
                  if(OrderCloseTime() > lastorder)
                    {
                    lastorder = OrderCloseTime();
                    newlots = OrderLots()*2;
                    if(OrderType() == OP_BUY)
                      {
                      if((OrderClosePrice() - OrderOpenPrice()) > 9*a*Point) newlots = Lots;
                      }
                    if(OrderType() == OP_SELL)
                      {
                      if((OrderOpenPrice() - OrderClosePrice()) > 9*a*Point) newlots = Lots;
                      }
                    }
                  }
                }
              }
            if(newlots > MarketInfo(Symbol(),MODE_MAXLOT))
              {
              newlots = MarketInfo(Symbol(),MODE_MAXLOT);
              }
            if(OrderSend(Symbol(),OP_BUY,newlots,Ask,Slippage,0,0,0,MagicNumber,0,BuyColor) > 0)
              {
              buytime = Time[0];
              }
            }
          }
        }
      }
    }
    
//----    
  int orderbat,ordersat;
  for(i=0;i<OrdersTotal();i++)
    {
    if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
      {
      if(OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)
        {
        if(OrderType() == OP_BUY)
          {
          buyprofit1 = NormalizeDouble(OrderOpenPrice() + 1*Point*a,Digits);
          buyprofit10 = NormalizeDouble(OrderOpenPrice() + 10*Point*a,Digits);
          buyprofit20 = NormalizeDouble(OrderOpenPrice() + 20*Point*a,Digits);
          buyprofit25 = NormalizeDouble(OrderOpenPrice() + 25*Point*a,Digits);
          orderbat = OrderOpenTime();
          }
        if(OrderType() == OP_SELL)
          {
          sellprofit1 = NormalizeDouble(OrderOpenPrice() - 1*Point*a,Digits);
          sellprofit10 = NormalizeDouble(OrderOpenPrice() - 10*Point*a,Digits);
          sellprofit20 = NormalizeDouble(OrderOpenPrice() - 20*Point*a,Digits);
          sellprofit25 = NormalizeDouble(OrderOpenPrice() - 25*Point*a,Digits);
          ordersat = OrderOpenTime();
          }
        }
      }
    }
    
  if(buys > 0)
    {
    ObjectDelete("buylevel1");
    ObjectCreate("buylevel1",OBJ_TREND,0,orderbat - 120*Period(),buyprofit1,Time[0],buyprofit1);
    ObjectSet("buylevel1",OBJPROP_RAY,0);
    ObjectSet("buylevel1",OBJPROP_TIME2,Time[0]);
    ObjectSet("buylevel1",OBJPROP_COLOR,BuyColor);
    
    ObjectDelete("buylevel10");
    ObjectCreate("buylevel10",OBJ_TREND,0,orderbat - 120*Period(),buyprofit10,Time[0],buyprofit10);
    ObjectSet("buylevel10",OBJPROP_RAY,0);
    ObjectSet("buylevel10",OBJPROP_TIME2,Time[0]);
    ObjectSet("buylevel10",OBJPROP_COLOR,BuyColor);
    
    ObjectDelete("buylevel20");
    ObjectCreate("buylevel20",OBJ_TREND,0,orderbat - 120*Period(),buyprofit20,Time[0],buyprofit20);
    ObjectSet("buylevel20",OBJPROP_RAY,0);
    ObjectSet("buylevel20",OBJPROP_TIME2,Time[0]);
    ObjectSet("buylevel20",OBJPROP_COLOR,BuyColor);
    
    ObjectDelete("buylevel25");
    ObjectCreate("buylevel25",OBJ_TREND,0,orderbat - 120*Period(),buyprofit25,Time[0],buyprofit25);
    ObjectSet("buylevel25",OBJPROP_RAY,0);
    ObjectSet("buylevel25",OBJPROP_TIME2,Time[0]);
    ObjectSet("buylevel25",OBJPROP_COLOR,BuyColor);
    }
    
  if(sells > 0)
    {
    ObjectDelete("selllevel1");
    ObjectCreate("selllevel1",OBJ_TREND,0,ordersat - 120*Period(),sellprofit1,Time[0],sellprofit1);
    ObjectSet("selllevel1",OBJPROP_RAY,0);
    ObjectSet("selllevel1",OBJPROP_TIME2,Time[0]);
    ObjectSet("selllevel1",OBJPROP_COLOR,SellColor);
    
    ObjectDelete("selllevel10");
    ObjectCreate("selllevel10",OBJ_TREND,0,ordersat - 120*Period(),sellprofit10,Time[0],sellprofit10);
    ObjectSet("selllevel10",OBJPROP_RAY,0);
    ObjectSet("selllevel10",OBJPROP_TIME2,Time[0]);
    ObjectSet("selllevel10",OBJPROP_COLOR,SellColor);
    
    ObjectDelete("selllevel20");
    ObjectCreate("selllevel20",OBJ_TREND,0,ordersat - 120*Period(),sellprofit20,Time[0],sellprofit20);
    ObjectSet("selllevel20",OBJPROP_RAY,0);
    ObjectSet("selllevel20",OBJPROP_TIME2,Time[0]);
    ObjectSet("selllevel20",OBJPROP_COLOR,SellColor);
    
    ObjectDelete("selllevel25");
    ObjectCreate("selllevel25",OBJ_TREND,0,ordersat - 120*Period(),sellprofit25,Time[0],sellprofit25);
    ObjectSet("selllevel25",OBJPROP_RAY,0);
    ObjectSet("selllevel25",OBJPROP_TIME2,Time[0]);
    ObjectSet("selllevel25",OBJPROP_COLOR,SellColor);
    }
    
//----   
  static double bclose,sclose = 9999,bclose2,sclose2 = 9999;
  for(i=0;i<OrdersTotal();i++)
    {
    if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
      {
      if(OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)
        {
        if(OrderType() == OP_BUY)
          {
          if(Bid >= buyprofit10) bclose = OrderOpenPrice() + 1*Point*a;
          if(Bid >= buyprofit20) bclose = OrderOpenPrice() + 10*Point*a;
          if(Bid >= buyprofit25) bclose = OrderOpenPrice() + 20*Point*a;
          }
        if(OrderType() == OP_SELL)
          {
          if(Ask <= sellprofit10) sclose = OrderOpenPrice() - 1*Point*a;
          if(Ask <= sellprofit20) sclose = OrderOpenPrice() - 10*Point*a;
          if(Ask <= sellprofit25) sclose = OrderOpenPrice() - 20*Point*a;
          }
        }
      }
    } 
  
  if(buys == 0)
    {
    
    bclose = 0;
    bclose2 = 0;
    }
  if(sells == 0)
    {
    sclose = 9999;
    sclose2 = 9999;
    }
  
  if(sclose < sclose2)
    {
    sclose2 = sclose;
    }
    
  if(bclose > bclose2)
    {
    bclose2 = bclose;
    }
  
  for(i=0;i<OrdersTotal();i++)
    {
    if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
      {
      if(OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)
        {
        if(OrderType() == OP_BUY)
          {
          if(bclose != 0)
            {
            if(Bid <= bclose2)
              {
              OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,BuyColor);
              }
            }
          }
        if(OrderType() == OP_SELL)
          {
          if(sclose != 0)
            {
            if(Ask >= sclose2)
              {
              OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,SellColor);
              }
            }
          }
        }
      }
    }
//----
  }
//+------------------------------------------------------------------+